package com.ca.SimpleTBluetoothGeiger;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.os.Bundle;
import android.util.Log;
import android.view.KeyEvent;
import android.view.SurfaceHolder;
import android.view.SurfaceView;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.Set;
import java.util.UUID;

import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothDevice;
import android.bluetooth.BluetoothSocket;

public class SimpleTBluetoothGeiger extends Activity {
	// google:BluetoothAdapter.getDefaultAdapter
	// http://techbooster.jpn.org/andriod/device/5833/

	private static final String TAG = "SBT";
	private static final int NO_RECIEVED_DATA = -1;
	private MySurfaceView mSurfaceView;
	private String mBluetoothPhaseMessage = "";
	private BluetoothAdapter mAdapter = null;

	// KCK[ǃJEg̐ώZl
	public volatile int mRawGeigerCount;
	// Xbh~p̕ϐ
	boolean isEnd = false;
	// ߋ̈莞Ԃ̃JEg
	int mSumOfCountInHistry = 0;
	// N莞ԌoāALȃf[^oĂ邩ǂ
	boolean mIsEffectiveData = false;
	boolean mIsGeigerConnect = false;

	short mDebugSoundMax;
	Context mContext;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);

		// mAdapter ̏́Athread̒ł炸ɁAł
		// thread ̒ƁAςɂȂB
		mAdapter = BluetoothAdapter.getDefaultAdapter();
		if (mAdapter == null) {
			Log.d("SOUND", "mAdapter=null");
		}
		mBluetoothPhaseMessage = "foCX̌B";
		if (!mAdapter.isEnabled()) {
			Log.d("SOUND", "enabler start");
			mAdapter.enable();// ION
			Log.d("SOUND", "enable end");
			SleepMs(500);
		}

		mSurfaceView = new MySurfaceView(this);
		setContentView(mSurfaceView);

	}

	@Override
	public void onStart() {
		super.onStart();
	}

	@Override
	public void onRestart() {
		super.onRestart();
	}

	@Override
	public void onResume() {
		super.onResume();
	}

	@Override
	public void onPause() {
		super.onPause();
	}

	@Override
	public void onStop() {
		super.onStop();
	}

	@Override
	public void onDestroy() {
		super.onDestroy();
		isEnd = true;
		Thread.interrupted();
	}

	@Override
	public boolean dispatchKeyEvent(KeyEvent event) {
		Log.d("SOUND", "dispatchKey");
		if (event.getAction() == KeyEvent.ACTION_DOWN) {
			switch (event.getKeyCode()) {
			case KeyEvent.KEYCODE_BACK:
				new AlertDialog.Builder(this).setIcon(R.drawable.icon).setTitle("I܂?").setMessage("").setPositiveButton("Yes",
						new DialogInterface.OnClickListener() {
							@Override
							public void onClick(DialogInterface dialog, int whichButton) {
								finish();
							}
						}).setNegativeButton("No", new DialogInterface.OnClickListener() {
					@Override
					public void onClick(DialogInterface dialog, int whichButton) {
					}
				}).show();
				return true;
			default:
				break;
			}
		} else if (event.getAction() == KeyEvent.ACTION_UP) {
			switch (event.getKeyCode()) {
			case KeyEvent.KEYCODE_BACK:
				return true;
			default:
				break;
			}
		}
		// ꂽ\bhEX^u
		return super.dispatchKeyEvent(event);
	}

	class MySurfaceView extends SurfaceView implements SurfaceHolder.Callback, Runnable {
		//Bitmap backGround;
		static final int HISTORY_MAX = 120;
		int mStartupCountDown = HISTORY_MAX;

		int[] mHistry = new int[HISTORY_MAX];
		int mHistryPtr = 0;

		public MySurfaceView(Context context) {
			super(context);
			mContext = context;

			getHolder().addCallback(this);

			// ThreadN
			Thread mThread = new Thread(this);
			mThread.start();

		}

		@Override
		public void run() {
			//backGround = BitmapFactory.decodeResource(mContext.getResources(), R.drawable.background);
			int rawLastGeigerCnt = mRawGeigerCount;
			int sumOfCount = 0;
			for (int i = 0; i < mHistry.length; i++) {
				mHistry[i] = 0;
			}
			SleepMs(300);
			Log.d("GAMEVIEW", "mGeigerDetect start");

			GeigerDetect mGeigerDetect = new GeigerDetect();
			// mGeigerDetect.run();
			mGeigerDetect.start();

			// TODO Auto-generated method stub
			while (!isEnd) {
				// OƂ̍߂
				int geiger = mRawGeigerCount;
				int deltaGeiger = geiger - rawLastGeigerCnt;
				rawLastGeigerCnt = geiger;
				Log.i("SOUND_GEIGER", "deltaGeiger=" + deltaGeiger);

				// ߋԕ̃JEgl߂
				sumOfCount -= mHistry[mHistryPtr];
				if (mHistry[mHistryPtr] > 0) {
					Log.i("SOUND_GEIGER", "minus " + mHistry[mHistryPtr]);
				}
				sumOfCount += deltaGeiger;
				mHistry[mHistryPtr] = deltaGeiger;
				mHistryPtr = incrimentHistryPtr(mHistryPtr);
				if (mHistryPtr == 0) {
					mIsEffectiveData = true;
				}

				// mSumOfCountInHistry ɓo^
				mSumOfCountInHistry = sumOfCount;
				if (mStartupCountDown > 0) {
					mStartupCountDown--;
				}
				Canvas canvas = getHolder().lockCanvas();
				if (canvas != null) {
					mSurfaceView.doDraw(canvas, mSumOfCountInHistry);
					getHolder().unlockCanvasAndPost(canvas);
				}
				SleepMs(500);
			}
		}

		void doDraw(Canvas canvas, int count) {
			Paint paint = new Paint();

			canvas.drawColor(Color.WHITE);

			//canvas.drawBitmap(backGround, 0, 0, paint);

			paint.setColor(Color.BLACK);
			paint.setAntiAlias(true);
			paint.setTextSize(40);
			int offsetX = 40;
			int offsetY = 40;

			if (mIsGeigerConnect == false) {
				paint.setTextSize(20);
				canvas.drawText("KCK[JE^TĂ܂B" + mBluetoothPhaseMessage, 0, paint.getTextSize(), paint);
				paint.setTextSize(30);
				canvas.drawText("ЃV[G[", 0 + offsetX, 300 + offsetY, paint);
				return;
			}

			if (mIsEffectiveData) {
				double dblValue = count;
				dblValue /= 300.0;
				dblValue *= 1.8;
				String str = String.format("%2.2f", dblValue);
				str += " uSv/h";
				canvas.drawText(str, 0 + offsetX, paint.getTextSize() + offsetY, paint);
			} else {
				paint.setTextSize(20);
				canvas.drawText("" + (mStartupCountDown / 2) + "b҂ ", 0 + offsetX, paint.getTextSize() + offsetY, paint);
				paint.setTextSize(40);
			}

			canvas.drawText("Count: " + count, 0 + offsetX, paint.getTextSize() * 2 + offsetY, paint);

			paint.setTextSize(10);
			canvas.drawText("TotalCount: " + mRawGeigerCount, 0 + offsetX, 120 + offsetY, paint);
			paint.setTextSize(10);
			canvas.drawText("MaxSound: " + mDebugSoundMax, 0 + offsetX, 140 + offsetY, paint);

			paint.setTextSize(30);
			canvas.drawText("ЃV[G[", 0 + offsetX, 300 + offsetY, paint);

		}

		public void surfaceChanged(SurfaceHolder holder, int format, int width, int height) {
			Log.d("TEST", "surfaceChanged");
		}

		public void surfaceCreated(SurfaceHolder holder) {
		}

		public void surfaceDestroyed(SurfaceHolder holder) {
			Log.d("TEST", "surfaceDestroyed");
		}

		int incrimentHistryPtr(int ptr) {
			ptr++;
			if (ptr >= mHistry.length) {
				ptr = 0;
			}
			return ptr;
		}
	}

	// bluetooth ̎MXbh
	class GeigerDetect extends Thread {
		private BluetoothDevice mDevice = null;
		private BluetoothSocket mSocket = null;
		private final UUID MY_UUID = UUID.fromString("00001101-0000-1000-8000-00805F9B34FB");
		private InputStream mInStream = null;
		private OutputStream mOutStream = null;
		//private final String DEVICE_NAME = "FireFly-9CB3";
		//private final String DEVICE_NAME = "FB155v2.2.1";
		private final String DEVICE_NAME = "CaGeiger";
		private byte[] mOneByteBuffer = new byte[1];// Iɍ肽Ȃ̂ŁAō

		@Override
		public void run() {
			Log.d("SOUND", "GeigerDetectThread");
			while (!isEnd) {
				mBluetoothPhaseMessage = "Bluetooth GeigerT";
				mIsGeigerConnect = false;
				while (!isEnd) {
					if (makeConnection() == true) {
						break;
					}
					Log.d("SOUND", "makeConnection error");
				}
				mBluetoothPhaseMessage = "ʐMB";
				if (stopAndGoCommand(mOutStream, mInStream) == false) {
					SleepMs(20000);
					cancel();
					continue;// error
				}
				while (!isEnd) {
					String readMsg = readLineWithTimeout(mInStream, 1000, 100, 10);
					Log.d("SOUND", "readMsg=" + readMsg);
					if (readMsg == null) {
						cancel();
						break;// error
					}
					mIsGeigerConnect = true;
					int value = strToInt(readMsg);
					if (value >= 0) {
						mRawGeigerCount += value;
					}
				}
			}
			cancel();
		}

		// ڑ𓾂
		boolean makeConnection() {
			mDevice = null;
			mSocket = null;
			mInStream = null;
			mOutStream = null;
			Log.d("SOUND", "makeConnection");

			// device 𓾂
			mDevice = getDevice(mAdapter, DEVICE_NAME);
			if (mDevice == null) {
				return false;
			}

			mAdapter.cancelDiscovery();

			// Oڑ̂܂܂ƁAgetSocket() mSocket.connect()œ~ɂȂ̂ŁAxN[Y
			mSocket = getSocket(mDevice, MY_UUID);
			if (mSocket == null) {
				Log.d("SOUND", "socket NG." + mSocket);
				return false;
			}
			try {
				mSocket.close();
			} catch (IOException e2) {
				return false;
			}

			for (int i = 0; i < 3; i++) {
				// ߂ getSocket()sB
				mSocket = getSocket(mDevice, MY_UUID);
				if (mSocket != null) {
					break;
				} else {
					Log.d("SOUND", "socket NG!!!!!!!!!!!!." + mSocket);
					SleepMs(500);
				}
			}
			if(mSocket==null) {
				return false ;
			}

			// connect
			Log.d("SOUND", "socket -----------------." + mSocket);
			try {
				mSocket.connect();
			} catch (IOException e1) {
				return false;
			}

			// stream ߂
			Log.d("SOUND", "socket ok." + mSocket);
			try {
				mInStream = mSocket.getInputStream();
				mOutStream = mSocket.getOutputStream();
				Log.d("SOUND", "mInStream " + mInStream);
				Log.d("SOUND", "mOutStream " + mOutStream);
				if ((mInStream != null) && (mOutStream != null)) {
					Log.d("SOUND", "stream ok." + mInStream);
					return true;
				}
			} catch (IOException e) {
				return false;
			}
			return true;
		}

		// JnR}h
		boolean stopAndGoCommand(OutputStream out, InputStream in) {
			Log.d("SOUND", "stopAndGoCommand.");

			// S~As
			for (int i = 0; i < 2; i++) {
				Log.d("SOUND", "stp.");
				writeLine(out, "stp");
				SleepMs(500);
			}
			SleepMs(500);
			Log.d("SOUND", "readout.");
			readOut(in);
			// JnR}h
			writeLine(out, "stt");
			return true;
		}

		// BluetoothDevice߂
		BluetoothDevice getDevice(BluetoothAdapter adapter, String deviceName) {
			Log.d("SOUND", "getDevice[" + deviceName + "]" + adapter);
			Set<BluetoothDevice> devices = adapter.getBondedDevices();
			Log.d("SOUND", "getDevice[" + deviceName + "]");
			if (devices == null) {
				Log.d("SOUND", "no device list");
				return null;
			}
			if (devices.isEmpty()) {
				Log.d("SOUND", "no device found");
				return null;
			}

			for (BluetoothDevice device : devices) {
				Log.i("SOUND", "DEVICE:" + device.getName());
				if (device.getName().equals(deviceName)) {
					return device;
				}
			}
			Log.i("SOUND", "getDevice error" + deviceName);
			return null;
		}

		// BluetoothSocket߂
		BluetoothSocket getSocket(BluetoothDevice device, UUID uuid) {
			BluetoothSocket socket = null;
			Log.d("SOUND", "getSocket." + device);
			try {
				Log.d("SOUND", "getSocket start");
				// create sockect
				socket = device.createRfcommSocketToServiceRecord(MY_UUID);
			} catch (IOException e) {
				Log.i(TAG, "Error:" + e);
			}
			Log.d("SOUND", "getSocket end." + socket + "." + device + "." + MY_UUID);
			return socket;
		}

		// 
		private boolean writeLine(OutputStream outputStream, String str) {
			str += "\n";
			try {
				outputStream.write(str.getBytes());
			} catch (IOException e) {
				Log.d("SOUND", "writeLine error");
				return false;
			}
			Log.d("SOUND", "writeLine ok");
			return true;
		}

		// ^CAEgt1sǂݍ
		private String readLineWithTimeout(InputStream inputStream, int firstTimeout, int contTimeout, int limit) {
			// Rg[R[hł͂Ȃŏ1ǂݎ
			int data;
			byte buf[] = new byte[limit];
			while (true) {
				data = readByteWithTimeout(inputStream, firstTimeout);
				if (data == NO_RECIEVED_DATA) {
					return null;
				}
				if (data >= ' ') {
					break;
				}
			}
			int ptr = 0;
			buf[ptr] = (byte) data;
			ptr++;
			while (true) {
				data = readByteWithTimeout(inputStream, contTimeout);
				if (data == NO_RECIEVED_DATA) {
					return null;
				}
				if (data >= ' ') {
					buf[ptr] = (byte) data;
					ptr++;
					if (ptr >= limit) {
						return new String(buf, 0, ptr);
					}
				} else {
					return new String(buf, 0, ptr);
				}
			}
		}

		// ^CAEgt1byteM
		private int readByteWithTimeout(InputStream inputStream, int TimeOutMilliSec) {
			if (TimeOutMilliSec <= 0) {
				TimeOutMilliSec = 1;
			}
			for (int i = 0; i < TimeOutMilliSec; i++) {
				try {
					if (inputStream.available() != 0) {
						int bytes = inputStream.read(mOneByteBuffer);
						return (int) mOneByteBuffer[0];
					} else {
						SleepMs(1);
					}
				} catch (IOException e) {
				}
			}
			return NO_RECIEVED_DATA;
		}

		// ܂Ă͂Sēǂ
		private void readOut(InputStream inputStream) {
			while (true) {
				try {
					int num = inputStream.available();
					if (num == 0) {
						return;
					}
					inputStream.read(mOneByteBuffer);
				} catch (IOException e) {
				}
			}
		}

		// N[Y
		public void cancel() {
			try {
				mInStream.close();
				mOutStream.close();
				mSocket.close();
			} catch (IOException e) {
			}
			mInStream = null;
			mOutStream = null;
			mSocket = null;
			mDevice = null;
			mAdapter = null;
		}
	}

	// 񂩂琔lւ̕ϊ
	int strToInt(String str) {
		int value = -1;
		try {
			value = Integer.parseInt(str);
		} catch (NumberFormatException e) {
		}
		return value;
	}

	// w莞ԑ҂
	private void SleepMs(int MilliSec) {
		try {
			Thread.sleep(MilliSec);
		} catch (Exception e) {
			Log.e(TAG, "sleep- " + e.getMessage());
		}
	}

}
